﻿using Infragistics.Windows.DataPresenter;
using Infragistics.Windows.Editors;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Interactivity;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace SetMaxLengthIndividual
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            xdg.DataContext = Data.GetData(5, 1, 10);
        }
    }
        public class Data : INotifyPropertyChanged
        {
            private int low;
            private int value;
            private string label;
            private int maxLength;

            public string Label
            {
                get { return label; }
                set
                {
                    label = value;
                    PropChanged("Label");
                }
            }

            public int Value1
            {
                get { return low; }
                set
                {
                    low = value;
                    PropChanged("Value1");
                }
            }

            public int Value
            {
                get { return value; }
                set
                {
                    this.value = value;
                    PropChanged("Value");
                }
            }


            public static ObservableCollection<Data> GetData(int points, int rangeStart, int rangeEnd)
            {
                ObservableCollection<Data> data = new ObservableCollection<Data>();
                Random r = new Random();
                for (int i = 0; i < points; i++)
                {
                    data.Add(new Data
                    {

                        Label = "Item " + i,
                        Value1 = r.Next(rangeStart, rangeEnd),
                        Value = r.Next(rangeStart, rangeEnd),
                    });
                }

                return data;
            }

            public event PropertyChangedEventHandler PropertyChanged;

            public void PropChanged(string name)
            {
                if (PropertyChanged != null)
                    PropertyChanged(this, new PropertyChangedEventArgs(name));
            }
        }

        public static class ValueConstraintBehavior
        {
            public static readonly DependencyProperty CustomMaxLengthProperty = DependencyProperty.RegisterAttached(
                "CustomMaxLength",
                typeof(int),
                typeof(ValueConstraintBehavior),
                new PropertyMetadata(default(int), CustomMaxLengthChanged));

            private static void CustomMaxLengthChanged(DependencyObject dependencyObject, DependencyPropertyChangedEventArgs eventArgs)
            {
               
                int result;
                var field = dependencyObject as Field;
                if (field != null && eventArgs.NewValue is int)
                {
                    field.PropertyChanged += (sender, args) =>
                        {
                            Int32.TryParse(eventArgs.NewValue.ToString(), out result);
                            ValueConstraint v = new ValueConstraint();
                            v.MaxLength = result;
                            if (field.ValueConstraint == null)
                            {
                                field.ValueConstraint = v;
                            }
                        };
                }
            }

            public static void SetCustomMaxLength(DependencyObject element, int value)
            {
                element.SetValue(CustomMaxLengthProperty, value);
            }

            public static int GeCustomMaxLength(DependencyObject element)
            {
                return (int)element.GetValue(CustomMaxLengthProperty);
            }
        }
}
